/*******************************************************************************/
/*   Program Name  : FlashROM.h
/*   Disctiption   : FlashROM SST29EE010 wb_[
/*   History       : Ver@1.00@@2009/06/11
/*
/*   Program       : garbagecollection (Alpha8)
/*
/*******************************************************************************/

#include	"2144s.h"

/******************************************************************************
 *  ϐ`
 ******************************************************************************/
#define FL_ADDR		0x400000		/* flash address */
#define FL_SRC		0x200000		/* ]JnAhX */
#define FL_END		0x201000		/* ]IAhX  */


#define	eeprom_address	0x400000
#define eeprom_5555H	*(volatile unsigned char *)(eeprom_address+0x5555)
#define eeprom_2AAAH	*(volatile unsigned char *)(eeprom_address+0x2AAA)								
#define eeprom_start	*(volatile unsigned char *)(eeprom_address)


static  unsigned char   EEPROM_BUF[128] ;
/*******************************************************************************/
/*   Function Name : Prototype declaration
/*   Disctiption   : vg^Cv錾
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void ChipErace(void);
void BWrite(unsigned int ,unsigned char );
void FWrite(int ,char[],int );
/*******************************************************************************/
/*   Function Name : ChipErace
/*   Disctiption   : SST29EE010 S
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void ChipErace(void)  /* S */
{
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0x80;
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0x10;
}
/*******************************************************************************/
/*   Function Name : BWrite
/*   Disctiption   : OneByteWrite
/*   Input         : addr:݃AhX@@ dat:݃f[^
/*   Output        : 
/*******************************************************************************/
void BWrite(unsigned int addr,unsigned char dat)
{
	int addr2,addr3,i;
	int eepad;
	char rdata;
	
	addr2 = addr & 0xffff80;
	addr3 = addr & 0x00007F;
	
	//Buffer128Byteǂݍ
	for(i=0;i<128;i++)
	{
		eepad = addr2 + i;
		EEPROM_BUF[i] = *(volatile char *)(eepad);
	}
	//Buffer֎wf[^
	EEPROM_BUF[addr3] = dat;

rdata=0x00;


	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0xA0;
	
	//FlashPROM128ByteBufferf[^
	for(i=0;i<128;i++)
	{
		eepad = addr2 + i;
		*(volatile char *)(eepad) = EEPROM_BUF[i];
	}
	//݌ `FbN
	while(1)
	{
		rdata= *(volatile char *)(eepad);
		if ((rdata & 0x80) == (EEPROM_BUF[127] & 0x80))
		{
          	break;
		}
	}
}
/*******************************************************************************/
/*   Function Name : FWrite
/*   Disctiption   : BufferWrite
/*   Input         : addr:݃AhX@@ dat[]:݃f[^
/*                 : len:݃f[^
/*   Output        : 
/*******************************************************************************/
void FWrite(int addr,char dat[],int len) 
{
	int addr2,addr3,addr4,i,j;
	int eepad;
	char rdata;
	
	addr2 = addr & 0xffff80;
	addr3 = addr & 0x00007F;

	j = 0;
	if (len > 128) len = 128;
	//Buffer128Byteǂݍ
	for(i=0;i<128;i++)
	{
		eepad = addr2 + i;
		EEPROM_BUF[i] = *(volatile char *)eepad;
	}
	//Buffer֎wf[^
	for(i=0;i<len;i++)
	{
	EEPROM_BUF[i] = dat[i];
	}
	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0xA0;
	
	//FlashPROM128ByteBufferf[^
	for(i=addr3;i<0x80;i++)
	{
		eepad = addr2 + i;
		*(volatile char *)eepad = EEPROM_BUF[j++];
	}
	//݌ `FbN
	while(1)
	{
		rdata= *(volatile char *)(eepad);
		if ((rdata & 0x80) == (EEPROM_BUF[j-1] & 0x80))
		{
          	break;
		}
	}

	eeprom_5555H=0xAA;
	eeprom_2AAAH=0x55;
	eeprom_5555H=0xA0;
	
	//FlashPROM128ByteBufferf[^
	for(i=0;i<addr3;i++)
	{
		eepad = addr2 + i+ 0x80;
		*(volatile char *)eepad = EEPROM_BUF[j++];
	}
	//݌ `FbN
	while(1)
	{
		rdata= *(volatile char *)(eepad);
		if ((rdata & 0x80) == (EEPROM_BUF[j-1] & 0x80))
		{
          	break;
		}
	}
}


